% fichier circuits.pl

ev_and(1,1,1).            
ev_and(X, Y, 0) :- X = 0; Y=0. 

ev_or(0, 0, 0).           
ev_or(X,Y,1) :- X=1 ; Y=1.

ev_xor(X,Y,0) :- X=Y.     
ev_xor(X,Y,1) :- X\=Y.

ev_neg(1,0).              
ev_neg(0,1).
    
add(A, B, C, xor(A,xor(B,C))).

eval(0,0).   eval(1,1).
eval(and(X,Y),R) :- eval(X,R1), eval(Y,R2), ev_and(R1,R2,R).
eval(or(X,Y), R) :- eval(X,R1), eval(Y,R2), ev_or(R1,R2,R).
eval(neg(X), R) :- eval(X,R1), ev_neg(R1,R).
eval(xor(X,Y), R) :- eval(X,R1), eval(Y,R2), ev_xor(R1,R2,R).

bin(0). bin(1).


 /*-----------------------------------------------------
 Question
 
?- add(1,0,0, Addi), eval(Addi,R).
  ?- bin(A), bin(B), bin(C),add(A,B,C, Ci), eval(Ci,R).
 
 --------------------------------------------------------*/